﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Excel = Microsoft.Office.Interop.Excel;
using System.IO;
using System.Threading;
using System.Diagnostics;

namespace excel_dde
{
    public partial class DDE_Test : Form
    {
        Excel.Application app = null;

        Excel.Workbook wb1 = null;
        Excel.Workbook wb2 = null;

        Excel.Worksheet ws11 = null;
        Excel.Worksheet ws12 = null;
        Excel.Worksheet ws13 = null;

        Excel.Worksheet ws21 = null;
        Excel.Worksheet ws22 = null;
        Excel.Worksheet ws23 = null;


        bool flagExitPrice1 = false;
        bool flagExitPrice2 = false;

        Stopwatch sw = new Stopwatch();


        public DDE_Test()
        {
            InitializeComponent();

            DebugConsole.CreateConsole();
        }

        private void cmdStartExel_Click(object sender, EventArgs e)
        {
            if (app != null) return;

            app = new Excel.Application();
            app.Visible = true;

            wb1 = app.Workbooks.Open(@"c:\DDE_Symbol_1.xlsx");
            wb2 = app.Workbooks.Open(@"c:\DDE_Symbol_2.xlsx");

            ws11 = wb1.Worksheets.get_Item(1);
            ws12 = wb1.Worksheets.get_Item(2);
            ws13 = wb1.Worksheets.get_Item(3);

            ws21 = wb2.Worksheets.get_Item(1);
            ws22 = wb2.Worksheets.get_Item(2);
            ws23 = wb2.Worksheets.get_Item(3);
        }

        private void cmdCloseExcel_Click(object sender, EventArgs e)
        {
            wb1.Close(false);
            wb2.Close(false);
            app.Quit();
        }

        // Start Price
        private void cmdWritePrice_Click(object sender, EventArgs e)
        {

            Thread t = new Thread(Wb1Thread);
            t.IsBackground = true;
            t.Start();
            sw.Restart();

        }


        private void Wb1Thread()
        {
            int price = 1;

            while (!flagExitPrice1)
            {

                ws11.Cells[1, 2] = price;
                ws11.Cells[1, 1] = price;

                ws12.Cells[1, 2] = price;
                ws12.Cells[1, 1] = price;

                ws13.Cells[1, 2] = price;
                ws13.Cells[1, 1] = price;

                price = price + 1;

                if (price % 1000 == 0) Console.WriteLine("price = {0}", price);

            }
            flagExitPrice1 = false;
        }


        // stop writing
        private void cmdStopPrice_Click(object sender, EventArgs e)
        {
            flagExitPrice1 = true;
            Console.WriteLine("speed = {0} cells / sec", (6 * ws11.Cells[1, 1].Value2 * 1000.0) / sw.ElapsedMilliseconds);
            Console.WriteLine("last value: Trade: {0}, {1}, Bid: {0}, {1}, Ask: {0}, {1}", 
                ws11.Cells[1, 1].Value2, ws11.Cells[1, 2].Value2,
                ws12.Cells[1, 1].Value2, ws11.Cells[1, 2].Value2);
        }

        public static class DebugConsole
        {
            [System.Runtime.InteropServices.DllImport("kernel32.dll")]
            public static extern bool AllocConsole();
            [System.Runtime.InteropServices.DllImport("kernel32.dll")]
            public static extern bool FreeConsole();
            [System.Runtime.InteropServices.DllImport("kernel32.dll")]
            public static extern IntPtr GetConsoleWindow();
            [System.Runtime.InteropServices.DllImport("user32.dll")]
            public static extern IntPtr SetWindowPos(IntPtr hWnd, int hWndInsertAfter, int x, int Y, int cx, int cy, int wFlags);

            static StreamWriter sw = null;
            static StreamReader sr = null;
            static StreamWriter swError = null;

            public static int CreateConsole()
            {
                int retval = 0;
                IntPtr retGetConsoleWindow = GetConsoleWindow();

                if (retGetConsoleWindow == (IntPtr)0)
                {
                    AllocConsole();

                    sw = new StreamWriter(Console.OpenStandardOutput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    sw.AutoFlush = true;
                    Console.SetOut(sw);

                    sr = new StreamReader(Console.OpenStandardInput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    Console.SetIn(sr);

                    swError = new StreamWriter(Console.OpenStandardOutput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    swError.AutoFlush = true;
                    Console.SetError(swError);

                    retval = 1;
                }
                else
                {
                    Console.WriteLine("Console already created. GetConsoleWindow returned {0}", retGetConsoleWindow.ToString());
                    retval = -1;
                }

                Console.WriteLine("CreateConsole finished.");

                return (retval);
            }

            public static int CreateConsoleEx(int x, int y, int width, int height)
            {
                int retval = 0;
                IntPtr retGetConsoleWindow = GetConsoleWindow();

                if (retGetConsoleWindow == (IntPtr)0)
                {
                    AllocConsole();

                    sw = new StreamWriter(Console.OpenStandardOutput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    sw.AutoFlush = true;
                    Console.SetOut(sw);

                    sr = new StreamReader(Console.OpenStandardInput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    Console.SetIn(sr);

                    swError = new StreamWriter(Console.OpenStandardOutput(), Encoding.GetEncoding("ks_c_5601-1987"));
                    swError.AutoFlush = true;
                    Console.SetError(swError);

                    SetWindowPos(GetConsoleWindow(), 0, x, y, width, height, 0x0040);

                    retval = 1;
                }
                else
                {
                    Console.WriteLine("Console already created. GetConsoleWindow returned {0}", retGetConsoleWindow.ToString());
                    SetWindowPos(GetConsoleWindow(), 0, x, y, width, height, 0x0040);
                    retval = -1;
                }

                Console.WriteLine("CreateConsole finished.");

                return (retval);
            }
        }
    }
}
